// ________________________________________
// 10.cpp
// ----------------------------------------

// .... What's new? .......................
// The same thing with binary numbers
//      Basis = 2
//      Adapt get_number
// ........................................

#include <iostream>       // for MS Visual C++

#define numbertype unsigned short int // Adapt to the number of positions
#define basis 2                       // Adapt to the numbering system
                                      // (decimal, hex, etc...)
#define small unsigned short int      // small must be great enough to
                                      // contain the basis
#define medium unsigned short int     // medium must be great enough to
                                      // contain the square of the basis
#define sufficient 200                // chane length for input

const numbertype positions = 50;      // a constant
bool overflow = false;                // a global variable


// - - - Auxiliary functions:  - - - - - - - - - - - - - - - - - - - - - - -


numbertype maxim (numbertype a, numbertype b);
void print (int number);
void wait ();
void cls ();
void gotoline ();
void dash ();
void space ();

numbertype maxim (numbertype a, numbertype b)
      // ----------------------------------
      // Determinates the maximum of two numbers
      // ----------------------------------
{
   numbertype max;

   if (a > b) max = a; else max = b;
   return (max);
}


void print (int number)
      // ----------------------------------
      // Number output on screen (for test purposes)
      // ----------------------------------
{
   std::cout  << number << " ";
}


void wait ()
      // ----------------------------------
      // Waits for <intro> to be pressed
      // ----------------------------------
{
    char s [sufficient];
    std::cout << "Press Intro";
    std::cin.getline (s, sufficient);
}


void cls ()
      // ----------------------------------
      // clear screen
      // ----------------------------------
{
    unsigned short int line;
    for (line = 0; line < 40; line++) std::cout << "\n";
}


void gotoline ()
      // ----------------------------------
      // put the cursor on the next line
      // ----------------------------------
{
    std::cout << "\n";
}


void dash ()
      // ----------------------------------
      // Makes dashed line of length = positions + 1
      // Puts the cursor to the beginning of the line
      // ----------------------------------
{
    unsigned short int i;
    for (i = 0; i <= positions; i++) std::cout << '_';
    std::cout << "";
    for (i = 0; i <= positions+3; i++) std::cout << "\b";
}


void space ()
      // ----------------------------------
      // Makes a space of the length of positions - 8
      // ----------------------------------
{
    unsigned short int i;
    for (i = 0; i <= positions - 8; i++) std::cout << ' ';
}

// - - - Class big_number: - - - - - - - - - - - - - - - - - - - - - - - - -


class big_number
      // ----------------------------------
      // Definition of class big_number
      // ----------------------------------
{
    small cipher [positions+1];
    numbertype  maxpos;
    bool positive;
  public:
    void get_number ();
    void write_0 ();
    void write ();
    void put_to_zero ();
    void put_to_one ();
    bool equal (big_number a, big_number b);
    bool bigger (big_number a, big_number b);
    void sum (big_number a, big_number b);
    void subt (big_number a, big_number b);
    void mult (big_number a, big_number b);
    void div (big_number a, big_number b, big_number &rest);
    void big_assign (big_number a);
    void gcd (big_number a, big_number b);
    void euclid (big_number a, big_number b);
    void lcm (big_number a, big_number b);
  private:
    void shift_left ();
};


// - - - big_number functions: - - - - - - - - - - - - - - - - - - - - - - -


void big_number::get_number ()
      // ----------------------------------
      // Number input from keyboard
      // ----------------------------------
{
   char s [sufficient];
   bool ok;
   bool final_reached;
   bool zero;              // the chain represents 0
   numbertype i, j, max;
   numbertype length;

   ok = false;

   while (ok == false)
       {
         final_reached = false;
         ok = true;
         zero = false;
         max = positions+1;

         // Initiating the string s to "BBBBBB...":
        for (j=0; j <= positions+3; j++) s [j] = 66;
        s [positions+4] = 0;

        std::cin.getline (s, sufficient);  // little change

         if ((s [0] == 48) && (s [2] == 66))   // If the chain represents 0
        {
           ok = true;
           zero = true;
         }
         else    // Usual case
         {
           for (i=0; i<=positions; i++)
             {
             if (s [i] == 0) final_reached = true;
             if (s [i] == 0) max = i;
             if (final_reached == false) if (s [i] < 48) ok = false;
// For binary numbers:
             if (final_reached == false) if (s [i] > 49) ok = false;
             }
           if (s [positions+1] == 0) final_reached = true;
           if (final_reached == false) ok = false;
           if (s [0] == 0) ok = false;
           if (s [0] == 48) ok = false; // not to begin number with 0

           for (i = 0; i < positions + 2; i++)
             if (s [i] == 0) length = i;
           if (length > positions + 1) ok = false;
         }
       if (ok == false) std::cout << "Error" << "\n";
     }

   // initialize:

   for (i = 0; i <= positions; i++) cipher [i] = 0;

   if (zero == false)
   {
      for (i = 0; i < max; i++) cipher [i] = s [max-i-1] - 48;

      // Determine maxpos:
         ok = false;
         i = positions+1;
         while (ok == false)
           {
             i--;
             if (cipher [i] != 0) ok = true;
           }
         maxpos = i;
   }
   else
   {
      maxpos = 0;
   }

   // The number entered is considered positive:
      positive = true;
}


void big_number::write_0 ()
      // ----------------------------------
      // Public accessor function
      // writes the big_number to screen
      // ----------------------------------
{
    if (overflow == false)
    {
      numbertype poscounter;
      if (positive == true) std::cout <<  "+"; else std::cout << "-";
      for (poscounter = positions; poscounter > 0; poscounter--)
        std::cout  << cipher [poscounter];
        std::cout  << cipher [0];  // write the last one

      std::cout <<  "   ";            // Control to be eliminated later
      std::cout << maxpos; //    << "\n\n";  // -------

      std::cout << "\n";
    }
    else  std::cout  << "Overflow Error!";
}


void big_number::write ()
      // ----------------------------------
      // Public accessor function
      // writes the big_number to screen
      // ----------------------------------
{
    if (overflow == false)
    {
      numbertype poscounter;
      bool reached = false;

      // if (positive == true) std::cout <<  "+"; else std::cout << "-";
      for (poscounter = positions; poscounter > 0; poscounter--)
          {
            if (cipher [poscounter] != 0) reached = true;
            if (reached == true)
              std::cout  << cipher [poscounter];
            else
              std::cout  << " ";
          }
        std::cout  << cipher [0];  // write the last one
    }
    else  std::cout  << "Overflow Error!";
}


void big_number::put_to_zero ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 0
      // ----------------------------------
{
    numbertype poscounter;

    for (poscounter = positions; poscounter > 0; poscounter--)
      cipher [poscounter] = 0;
      cipher [poscounter] = 0;  // the last one (position 0)
    maxpos = 0;
    positive = true;
}


void big_number::put_to_one ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 1
      // ----------------------------------
{
  put_to_zero ();
  cipher [0] = 1;
}


bool big_number::equal (big_number a, big_number b)
      // ----------------------------------
      // Gives true if the numbers are equal
      // ----------------------------------
{
  numbertype i;
  bool identic;
  identic = true;

  if (a.maxpos != b.maxpos) identic = false;
  for (i=0; i<=positions; i++)
    {
      if (a.cipher [i] != b.cipher [i]) identic = false;
    }

  return (identic);
}


bool big_number::bigger (big_number a, big_number b)
      // ----------------------------------
      // Gives true if    a > b
      // ----------------------------------
{
  numbertype k;
  bool is_bigger;
  bool enough;

  k = maxim (a.maxpos, b.maxpos);
  enough = false;
  is_bigger = false;

  while (enough == false)
    {
      if (a.cipher [k] < b.cipher [k]) enough = true;
      if (a.cipher [k] > b.cipher [k])
        {
          is_bigger = true;
          enough = true;
        }
      if (k == 0) enough = true;
      k--;
    }
  return (is_bigger);
}


void big_number::big_assign (big_number a)
      // ----------------------------------
      // Assign a big_number to another,
      // as used in gcd
      // ----------------------------------
{
   numbertype i;

   // to copy the ciphers
   for (i = 0; i <= positions; i++)
     {
       cipher [i] = a.cipher [i];
     }

   maxpos = a.maxpos;
   positive = a.positive;
}


void big_number::sum (big_number a, big_number b)
      // ----------------------------------
      // The sum of a and b
      // ----------------------------------
{
   numbertype i, n;
   medium s, keep;

   if (overflow != true)
   {
     put_to_zero ();                                 // sum = 0
     n = maxim (a.maxpos, b.maxpos);
     keep = 0;
     for (i = 0; i <= n; i++)
       {
         s = a.cipher [i] + b.cipher [i] + keep;
         keep = s / basis;         // in Pascal it would be: s DIV basis
         cipher [i] = s % basis;   // in Pascal it would be: s MOD basis
       }

     if (keep != 0) if (n == positions) overflow = true;
     if (keep != 0) if (n < positions)
        {
          n++;
          cipher [n] = keep;
        }
     maxpos = n;
   }
}


void big_number::subt (big_number a, big_number b)
      // ----------------------------------
      // The difference of a and b
      // Only works if a >= b
      // ----------------------------------
{
   numbertype i, last;
   medium d, keep;
   bool found = false;

   if (overflow != true)
   {
     put_to_zero ();                                 // subt = 0
     last = maxim (a.maxpos, b.maxpos);
     keep = 0;
     for (i = 0; i <= last; i++)
       {
         if (a.cipher [i] >= (b.cipher [i] + keep) )
           {
             d = a.cipher [i] - b.cipher [i] - keep;
             keep = 0;
           }
         else
           {
             d = basis + a.cipher [i] - b.cipher [i] - keep;
             keep = 1;
           }
         cipher [i] = d;
       }
     if (keep != 0) overflow = true;

     // to determinate maxpos:
     for (i = positions; i > 0; i--)
         {
           if (found == false) if (cipher [i] != 0)
             {
               maxpos = i;
               found = true;
             }
         }
     if (found == false) maxpos = 0;

   }
}



void big_number::shift_left ()
      // ----------------------------------
      // Multiplication with the basis
      // ----------------------------------
{
   numbertype i;
   bool is_zero;

   if (overflow != true)
   {
     if (maxpos == positions)
       overflow = true;
     else
     {
       if ((maxpos == 0) && (cipher [0] == 0))        // && is AND
              is_zero = true;
       else   is_zero = false;

       for (i = maxpos + 1; i > 0; i--) cipher [i] = cipher [i - 1];

       cipher [0] = 0;
       if (is_zero == false) maxpos++;
     }
   }
}



void big_number::mult (big_number a, big_number b)
      // ----------------------------------
      // The product of a and b
      // ----------------------------------
{
   numbertype i, j, k;
   medium keep, p;
   bool exit = false;
   bool found = false;

   big_number partial, result, auxiliar;

   if (overflow != true)
   {
     put_to_zero ();                                 // sum = 0
     partial.put_to_zero ();
     result.put_to_zero ();
     auxiliar.put_to_zero ();

     // If one of the factors is zero, the product is zero:
     if (equal (partial, a) == true) exit = true;
     if (equal (partial, b) == true) exit = true;

     // If both factors different from zero:
     if (exit == false)
     {
         for (j = 0; j <= b.maxpos; j++)
         {
           partial.put_to_zero ();
           partial.maxpos = positions;  // Even if the first positions may be 0
           keep = 0;
           for (i = 0; i <= positions; i++)
             {
               k = i + j;
               p = a.cipher [i] * b.cipher [j] + keep;
               if (k <= positions) partial.cipher [k] = p % basis;
               keep = p / basis;
               if (k > positions) if (p > 0) overflow = true;
             }
           if (keep != 0) if (k <= positions)
             {
               partial.cipher [k+1] = keep;
             }

           auxiliar = result;

           result.sum (auxiliar, partial);
         }                                 //  for (j = 0; j <= positions; j++)

       // to copy the ciphers
       for (i = 0; i <= positions; i++)
         {
           cipher [i] = result.cipher [i];
         }

       // to determinate maxpos:
       for (i = positions; i > 0; i--)
         {
           if (found == false) if (cipher [i] != 0)
             {
               maxpos = i;
               found = true;
             }
         }
       if (found == false) maxpos = 0;
     }                                                    // if (exit == false)
   }                                                   // if (overflow != true)
}



void big_number::div (big_number a, big_number b, big_number &rest)
      // ----------------------------------
      // The quotient of a and b, a / b
      //   rest is passed by reference and so
      //   its global value can be changed
      // ----------------------------------
{
   numbertype i, pos;
   big_number aux, z;
   bool enough = false, exit = false, found = false;
   small times;


   if (overflow != true)
   {
     z.put_to_zero ();     // to compare with zero

     if (b.equal (b, z) == true)
        {
          overflow = true;
          exit = true;
        }

     if (b.bigger (b, a) == true)
        {
           put_to_zero ();  // puts quotient to zero
           rest = a;
           exit = true;
        }

     if (exit == false)
        {
          put_to_zero ();
          aux.put_to_zero ();
          rest.put_to_zero ();

          pos = positions;
          aux.cipher [0] = a.cipher [pos];

          while (enough == false)
            {
              times = 0;
              while (   (aux.equal (aux, b) == true)
                     || (aux.bigger (aux, b) == true))       // || means OR
                {
                  times++;
                  aux.subt (aux, b);
                }
              cipher [pos] = times;
              if (pos > 0) pos--;
                           else enough = true;
              if (enough == false)
                {
                  aux.shift_left ();
                  aux.cipher [0] = a.cipher [pos];
                }
            }                                        // while (enough == false)
          rest = aux;

          // to determinate maxpos of quotient:
          for (i = positions; i > 0; i--)
            {
              if (found == false) if (cipher [i] != 0)
                {
                  maxpos = i;
                  found = true;
                }
            }
          if (found == false) maxpos = 0;

          // to determinate maxpos of rest:
          found = false;
          for (i = positions; i > 0; i--)
            {
              if (found == false) if (rest.cipher [i] != 0)
                {
                  rest.maxpos = i;
                  found = true;
                }
            }
          if (found == false) rest.maxpos = 0;

        }                                                 // if (exit == false)
   }                                                   // if (overflow != true)
}


void big_number::gcd (big_number a, big_number b)
      // ----------------------------------
      // The Greatest Common Divisor of a and b
      // ----------------------------------
{
   big_number zero, quotient, rest;

   zero.put_to_zero ();
   if (equal (a, zero) == true) overflow = true;
   if (equal (b, zero) == true) overflow = true;

   if (overflow != true)
     {
       rest.put_to_one (); // A arbitrary value different from 0
       while (equal (rest, zero) != true)
         {
           quotient.div (a, b, rest);
           a = b;
           b = rest;
         }
       big_assign (a);  // Result of the method is a
     }
}



void big_number::euclid (big_number a, big_number b)
      // ----------------------------------
      // The Greatest Common Divisor of a and b
      // and the representation of the Euclidic algorithm
      // ----------------------------------
{
   big_number zero, quotient, rest;
//   unsigned short int lines;

   zero.put_to_zero ();
   if (equal (a, zero) == true) overflow = true;
   if (equal (b, zero) == true) overflow = true;

   if (overflow != true)
     {
       rest.put_to_one (); // A arbitrary value different from 0

       gotoline ();

//       lines = 1;

       while (equal (rest, zero) != true)
         {

//           if ((lines % 1) == 0)
//             {
//                lines = 1;
//                wait ();
//             }
//           lines++;

           quotient.div (a, b, rest);

               a.write ();
               gotoline ();
               space ();
               std::cout  << "=";
               gotoline ();

               quotient.write ();
               gotoline ();
               space ();
               std::cout  << "*";
               gotoline ();

               b.write ();
               gotoline ();
               space ();
               std::cout  << "+";
               gotoline ();

               rest.write ();
               gotoline ();
               gotoline ();
               gotoline ();

           a = b;
           b = rest;
           wait ();
         }                                                     // while
       big_assign (a);  // Result of the method is a
     }
}


void big_number::lcm (big_number a, big_number b)
      // ----------------------------------
      // The Lowest Common Multiple of a and b
      // (a * b) / (gcd of a and b)
      // ----------------------------------
{
   big_number zero, max, q, r;

   zero.put_to_zero ();
   if (equal (a, zero) == true) overflow = true;
   if (equal (b, zero) == true) overflow = true;

   if (overflow != true)
     {
       max.gcd (a, b);
       q.div (a, max, r);  // max divides a, so now we only have to
                           // multiply q and b
       mult (q, b);
     }
}



// - - - Other functions - - - - - - - - - - - - - - - - - - - - - - - - - -

void menu ();
void menu_01 ();
void menu_02 ();
void menu_03 ();
void menu_04 ();   // Addition
void menu_05 ();   // Subtraktion
void menu_06 ();   // Multiplikation
void menu_07 ();   // Division


void menu ()
      // ----------------------------------
      // Menu text
      // ----------------------------------
{
  std::cout << "Bruchrechner fr Binrzahlen\n";
  std::cout << "----------------------------\n";
  std::cout << "\n";
  std::cout << "1) Ggt und kgV von zwei Zahlen\n";
  std::cout << "2) Euklidischer algorithmus\n";
  std::cout << "3) Krzen eines Bruchs\n";
  std::cout << "4) Addieren von zwei Brchen\n";
  std::cout << "5) Subtrahieren von zwei Brchen\n";
  std::cout << "6) Multiplizieren von zwei Brchen\n";
  std::cout << "7) Dividieren von zwei Brchen\n";
}


void menu_01 ()
      // ----------------------------------
      // ggT und kgV
      // ----------------------------------
{
  cls ();
  std::cout << "GgT und kgV von zwei Zahlen\n";
  std::cout << "---------------------------\n";
  gotoline ();

  big_number a, b, ggt, kgv;

  gotoline ();
  std::cout << "Geben Sie die erste  Zahl ein ";
  gotoline (); dash ();
  a.get_number ();

  gotoline ();
  std::cout << "Geben Sie die zweite Zahl ein ";
  gotoline (); dash ();
  b.get_number (); gotoline ();

  ggt.gcd (a, b);
  kgv.lcm (a, b);


  std::cout << "Der ggT der beiden Zahlen lautet: \n";
  ggt.write ();
  gotoline ();
  gotoline ();

  std::cout << "Das kgV der beiden Zahlen lautet: \n";
  kgv.write ();

}


void menu_02 ()
      // ----------------------------------
      // Euklides
      // ----------------------------------
{
  cls ();
  std::cout << "Euklidischer Algorithmus\n";
  std::cout << "------------------------\n";
  gotoline ();

  big_number a, b;

  gotoline ();
  std::cout << "Geben Sie die erste  Zahl ein ";
  gotoline (); dash ();
  a.get_number ();

  gotoline ();
  std::cout << "Geben Sie die zweite Zahl ein ";
  gotoline (); dash ();
  b.get_number (); gotoline ();

  a.euclid (a, b);
  gotoline ();
  std::cout << "Der ggT der beiden Zahlen lautet: \n";
  a.write ();
  gotoline ();


}


void menu_03 ()
      // ----------------------------------
      // Bruch krzen
      // ----------------------------------
{
  cls ();
  std::cout << "Einen Bruch krzen\n";
  std::cout << "------------------\n";
  gotoline ();

  big_number a, b, ggt, r;

  gotoline ();
  std::cout << "Geben Sie den Zhler des Bruchs ein ";
  gotoline (); dash ();
  a.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des Bruchs ein ";
  gotoline (); dash ();
  b.get_number (); gotoline ();

  ggt.gcd (a, b);
  a.div (a, ggt, r);
  b.div (b, ggt, r);

  std::cout << "Der Zhler des gekrzten Bruchs lautet: \n";
  a.write ();
  gotoline ();
  gotoline ();

  std::cout << "Der Nenner des gekrzten Bruchs lautet: \n";
  b.write ();

}


void menu_04 ()
      // ----------------------------------
      // Summe
      // ----------------------------------
{
  cls ();
  std::cout << "Zwei Brche addieren\n";
  std::cout << "--------------------\n";
  gotoline ();

  big_number z1, n1, z2, n2, kgv, ggt, r, faktor;
  big_number zero;
  zero.put_to_zero ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des ersten Bruchs ein ";
  gotoline (); dash ();
  z1.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des ersten Bruchs ein ";
  gotoline (); dash ();
  n1.get_number (); gotoline ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des zweiten Bruchs ein ";
  gotoline (); dash ();
  z2.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des zweiten Bruchs ein ";
  gotoline (); dash ();
  n2.get_number (); gotoline ();

  kgv.lcm (n1, n2);     // Gemeinsamer Nenner

  faktor.div (kgv, n1, r);  // Mit diesem 'faktor' muss der erste
                            // Bruch erweitert werden
  z1.mult (faktor, z1);     // Ergibt den neuen Zhler

  faktor.div (kgv, n2, r);  // Mit diesem 'faktor' muss der zweite
                            // Bruch erweitert werden
  z2.mult (faktor, z2);     // Ergibt den neuen Zhler

  z1.sum (z1, z2);          // z1 ist jetzt der neue Zhler,
  n1 = kgv;                 // kgv ist der neue Nenner

  // Der Bruch muss noch gekrzt werden, aber nur wenn der Zhler
  // von 0 verschieden ist:
  if (zero.equal (zero, z1) == false)
    {
      ggt.gcd (z1, n1);
      z1.div (z1, ggt, r);
      n1.div (n1, ggt, r);
    }
  else n1.put_to_one ();  // Nenner 1 setzen, falls Zhler == 0

  std::cout << "Der Zhler des Bruchs lautet: \n";
  z1.write ();
  gotoline ();
  gotoline ();

  std::cout << "Der Nenner des Bruchs lautet: \n";
  n1.write ();

}


void menu_05 ()
      // ----------------------------------
      // Differenz
      // ----------------------------------
{
  cls ();
  std::cout << "Zwei Brche subtrahieren\n";
  std::cout << "------------------------\n";
  gotoline ();

  big_number z1, n1, z2, n2, kgv, ggt, r, faktor;
  bool ist_negativ = false;
  big_number zero;
  zero.put_to_zero ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des ersten Bruchs ein ";
  gotoline (); dash ();
  z1.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des ersten Bruchs ein ";
  gotoline (); dash ();
  n1.get_number (); gotoline ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des zweiten Bruchs ein ";
  gotoline (); dash ();
  z2.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des zweiten Bruchs ein ";
  gotoline (); dash ();
  n2.get_number (); gotoline ();

  kgv.lcm (n1, n2);     // Gemeinsamer Nenner

  faktor.div (kgv, n1, r);  // Mit diesem 'faktor' muss der erste
                            // Bruch erweitert werden
  z1.mult (faktor, z1);     // Ergibt den neuen Zhler

  faktor.div (kgv, n2, r);  // Mit diesem 'faktor' muss der zweite
                            // Bruch erweitert werden
  z2.mult (faktor, z2);     // Ergibt den neuen Zhler

  if (z1.bigger (z1, z2) == false) ist_negativ = true;
  // In diesem Fall mssen die Zhler vertauscht werden
  if (ist_negativ == true)
    {
       r  = z1;
       z1 = z2;
       z2 = r;
    }

  z1.subt (z1, z2);         // z1 ist jetzt der neue Zhler,
  n1 = kgv;                 // kgv ist der neue Nenner

  // Der Bruch muss noch gekrzt werden, aber nur wenn der Zhler
  // von 0 verschieden ist:
  if (zero.equal (zero, z1) == false)
    {
      ggt.gcd (z1, n1);
      z1.div (z1, ggt, r);
      n1.div (n1, ggt, r);
    }
  else n1.put_to_one ();  // Nenner 1 setzen, falls Zhler == 0

  std::cout << "Der Zhler des Bruchs lautet: \n";
  z1.write ();
  gotoline ();
  gotoline ();

  std::cout << "Der Nenner des Bruchs lautet: \n";
  n1.write ();

  gotoline ();
  if (ist_negativ == true)
     if (zero.equal (zero, z1) == false)  // 0 wird nicht als negativ
                                          // bezeichnet
        std::cout << "Der Bruch ist negativ! \n";

}


void menu_06 ()
      // ----------------------------------
      // Multiplizieren von Brchen
      // ----------------------------------
{
  cls ();
  std::cout << "Zwei Brche multiplizieren\n";
  std::cout << "--------------------------\n";
  gotoline ();

  big_number z1, n1, z2, n2, zzz, nnn, ggt, r;
  big_number zero;
  zero.put_to_zero ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des ersten Bruchs ein ";
  gotoline (); dash ();
  z1.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des ersten Bruchs ein ";
  gotoline (); dash ();
  n1.get_number (); gotoline ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des zweiten Bruchs ein ";
  gotoline (); dash ();
  z2.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des zweiten Bruchs ein ";
  gotoline (); dash ();
  n2.get_number (); gotoline ();

  zzz.mult (z1, z2);  // Neuer Zhler
  nnn.mult (n1, n2);  // Neuer Nenner

  // Der Bruch muss noch gekrzt werden, aber nur wenn der Zhler
  // von 0 verschieden ist:
  if (zero.equal (zero, zzz) == false)
    {
      ggt.gcd (zzz, nnn);
      zzz.div (zzz, ggt, r);
      nnn.div (nnn, ggt, r);
    }
  else nnn.put_to_one ();  // Nenner 1 setzen, falls Zhler == 0

  std::cout << "Der Zhler des Bruchs lautet: \n";
  zzz.write ();
  gotoline ();
  gotoline ();

  std::cout << "Der Nenner des Bruchs lautet: \n";
  nnn.write ();

}



void menu_07 ()
      // ----------------------------------
      // Dividieren von Brchen
      // Multiplizieren mit Reziprokwert
      // ----------------------------------
{
  cls ();
  std::cout << "Zwei Brche dividieren\n";
  std::cout << "----------------------\n";
  gotoline ();

  big_number z1, n1, z2, n2, zzz, nnn, ggt, r;
  big_number zero;
  zero.put_to_zero ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des ersten Bruchs ein ";
  gotoline (); dash ();
  z1.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des ersten Bruchs ein ";
  gotoline (); dash ();
  n1.get_number (); gotoline ();

  gotoline ();
  std::cout << "Geben Sie den Zhler des zweiten Bruchs ein ";
  gotoline (); dash ();
  z2.get_number ();

  gotoline ();
  std::cout << "Geben Sie den Nenner des zweiten Bruchs ein ";
  gotoline (); dash ();
  n2.get_number (); gotoline ();

  // Reziprokwert
  r = z2; z2 = n2; n2 = r;

  zzz.mult (z1, z2);  // Neuer Zhler
  nnn.mult (n1, n2);  // Neuer Nenner

  // Der Bruch muss noch gekrzt werden, aber nur wenn der Zhler
  // von 0 verschieden ist:
  if (zero.equal (zero, zzz) == false)
    {
      ggt.gcd (zzz, nnn);
      zzz.div (zzz, ggt, r);
      nnn.div (nnn, ggt, r);
    }
  else nnn.put_to_one ();  // Nenner 1 setzen, falls Zhler == 0

  std::cout << "Der Zhler des Bruchs lautet: \n";
  zzz.write ();
  gotoline ();
  gotoline ();

  std::cout << "Der Nenner des Bruchs lautet: \n";
  nnn.write ();

}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


int main ()
      // **********************************
      //      Main function
      // **********************************
{
  char s [25];

  cls ();

  menu ();
  std::cout << "\n\n";
  std::cout << "Whlen Sie eine Option und drcken Sie <Intro> ";

  std::cin.getline (s, 25);

  if (s [0] == 49)   menu_01 ();   // ggT, kgV
                                   // ASCII-code of "1" is 49
  if (s [0] == 50)   menu_02 ();   // Euklides
  if (s [0] == 51)   menu_03 ();   // Krzen
  if (s [0] == 52)   menu_04 ();   // Addieren
  if (s [0] == 53)   menu_05 ();   // Subtrahieren
  if (s [0] == 54)   menu_06 ();   // Multiplizieren
  if (s [0] == 55)   menu_07 ();   // Dividieren

  gotoline ();

return 0;
}